var tru1 = GetComponentByNameAndType("TransferUnit1", "Transfer Unit");
var con1 = GetComponentByNameAndType("Conveyor1", "Conveyor");
var con2 = GetComponentByNameAndType("Conveyor2", "Conveyor");
var con3 = GetComponentByNameAndType("Conveyor3", "Conveyor");
var con4 = GetComponentByNameAndType("Conveyor4", "Conveyor");


var straightBlock = false;
var leftBlock = false;
var rightBlock = false;

var testCount = 1;
var testEachConveyor = 3;

function OnSimulationStart()
{
    LogDebug("OnSimulationStart called");
		
	SetTimerEx(1, 1000, "Conveyor1Test", null);
}

function Conveyor1Test()
{
	if(testCount==1)
	{
		tru1.TransferLeft = false;
		tru1.TransferRight = false;
	}
	if(testCount==2)
	{
		tru1.TransferRight = true;
		con3.Reverse = true;
	}
	if(testCount==3)
	{
		tru1.TransferLeft = true;
		
	}
	MoveProduct(CreateProduct(),"Conveyor1",0);
	
	if(testCount==testEachConveyor)
	{
		testCount = 1;
		SetTimerEx(1, 7000, "Conveyor3Test", null);
	}
	else
	{
		testCount++;
		SetTimerEx(1, 7000, "Conveyor1Test", null);
	}
}

function Conveyor3Test()
{
	if(testCount==1)
	{
		con3.Reverse = false;
		tru1.TransferLeft = false;
		tru1.TransferRight = false;
		tru1.TransferUp = true;
	}
	if(testCount==2)
	{
		tru1.TransferRight = true;
		
	}
		
	if(testCount==3)
	{
		tru1.TransferLeft = true;
		con1.Reverse = true;
		
	}
	MoveProduct(CreateProduct(),"Conveyor3",0);
	
	if(testCount==testEachConveyor)
	{
		testCount = 1;
		SetTimerEx(1, 7000, "Conveyor2Test", null);
	}
	else
	{
		testCount++;
		SetTimerEx(1, 7000, "Conveyor3Test", null);
	}
}

function Conveyor2Test()
{
	if(testCount==1)
	{
		con2.Reverse = true;
		tru1.TransferLeft = false;
		tru1.TransferRight = false;
		tru1.TransferUp = false;
	}
	if(testCount==2)
	{
		con4.Reverse = false;
		tru1.TransferRight = true;
		
	}
		
	if(testCount==3)
	{
		tru1.TransferLeft = true;
		con3.Reverse = true;
		
	}
	MoveProduct(CreateProduct(),"Conveyor2",3);
	
	if(testCount==testEachConveyor)
	{
		testCount = 1;
		SetTimerEx(1, 7000, "Conveyor4Test", null);
	}
	else
	{
		testCount++;
		SetTimerEx(1, 7000, "Conveyor2Test", null);
	}
}

function Conveyor4Test()
{
	if(testCount==1)
	{
		con2.Reverse = false;
		con4.Reverse = true;
		tru1.TransferLeft = false;
		tru1.TransferRight = false;
		tru1.TransferUp = true;
	}
	if(testCount==2)
	{
		
		tru1.TransferRight = true;
		
	}
		
	if(testCount==3)
	{
		tru1.TransferLeft = true;
		
		
	}
	MoveProduct(CreateProduct(),"Conveyor4",3);
	
	if(testCount==testEachConveyor)
	{
		testCount = 1;
	}
	else
	{
		testCount++;
		SetTimerEx(1, 7000, "Conveyor4Test", null);
	}
}


function OnSimulationStopping() 
{
    LogDebug("OnSimulationStopping called");
    DeleteAllProducts();
}

function OnSimulationStop()
{
    LogDebug("OnSimulationStop called");
}